/*!
* @file Item.h
* @brief ゲーム中のアイテムと付随要素のプロトタイプ
* @date 2013/12/11
* @author Deskull
* 2013 Sikabane Works.
*/

#pragma once

#include "stdafx.h"
#include "Deeangband.h"

#include "Dice.h"
#include "Effect.h"
#include "GameInstance.h"
#include "ItemBase.h"
#include "ItemTemplate.h"
#include "SavingTable.h"
#include "HaveGameTime.h"
#include "HaveSymbol.h"
#include "HavePosition.h"

BOOST_CLASS_VERSION(Item, 1);

namespace Deeangband
{

	/*!
	* @class Item
	* @brief アイテムのクラス
	*/
	class Item : public ItemTemplate, public GameInstance, public HaveGameTime, public HavePosition
	{
	private:

		Dice baseDamage; //!< ベースダメージのダイス
		WEIGHT weight; //!< アイテムの重量
		SavingTable baseSaving; //!< 基本セービング修正
		SavingTable plusSaving; //!< 追加セービング修正

		friend class boost::serialization::access;

		/*!
		* @brief クラスのシリアライズを設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param version データバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int version) 
		{
			if(version >= 0)
			{
				archive & boost::serialization::make_nvp("BaseDamage", baseDamage);
				archive & boost::serialization::make_nvp("Weight", weight);
				archive & boost::serialization::make_nvp("BaseSaving", baseSaving);
				archive & boost::serialization::make_nvp("PlusSaving", plusSaving);
			}
		}

	public:

		/*! 
		* @brief Itemクラスコンストラクタ
		*/
		Item::Item(void);

		/*! 
		* @brief Itemクラスコンストラクタ
		* @param itemBaseIt
		*/
		Item::Item(std::map<TAG, boost::shared_ptr<ItemBase>>::iterator itemBaseIt);

		/*! 
		* @brief Itemクラスデストラクタ
		*/
		Item::~Item(void);

		/*! 
		* @brief ダミーデータによる初期化
		* @return なし
		*/
		void Item::WipeData(void);

		/*! 受けた効果を処理する */
		bool Item::TakeEffect(Effect *effectPtr, POWER amount);


		/*!
		* @brief XMLシリアライズによるゲームデータ保存処理
		* @return なし
		*/
		void Item::XMLSave(std::string filename);

	};

}
